/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the MediaCenterFileCreate type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MediaCenterFileCreate{}

// MediaCenterFileCreate struct for MediaCenterFileCreate
type MediaCenterFileCreate struct {
	Key string `json:"key"`
	OrganizationWide *bool `json:"organization_wide,omitempty"`
	Public *bool `json:"public,omitempty"`
}

// NewMediaCenterFileCreate instantiates a new MediaCenterFileCreate object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMediaCenterFileCreate(key string) *MediaCenterFileCreate {
	this := MediaCenterFileCreate{}
	this.Key = key
	return &this
}

// NewMediaCenterFileCreateWithDefaults instantiates a new MediaCenterFileCreate object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMediaCenterFileCreateWithDefaults() *MediaCenterFileCreate {
	this := MediaCenterFileCreate{}
	return &this
}

// GetKey returns the Key field value
func (o *MediaCenterFileCreate) GetKey() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Key
}

// GetKeyOk returns a tuple with the Key field value
// and a boolean to check if the value has been set.
func (o *MediaCenterFileCreate) GetKeyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Key, true
}

// SetKey sets field value
func (o *MediaCenterFileCreate) SetKey(v string) {
	o.Key = v
}

// GetOrganizationWide returns the OrganizationWide field value if set, zero value otherwise.
func (o *MediaCenterFileCreate) GetOrganizationWide() bool {
	if o == nil || IsNil(o.OrganizationWide) {
		var ret bool
		return ret
	}
	return *o.OrganizationWide
}

// GetOrganizationWideOk returns a tuple with the OrganizationWide field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaCenterFileCreate) GetOrganizationWideOk() (*bool, bool) {
	if o == nil || IsNil(o.OrganizationWide) {
		return nil, false
	}
	return o.OrganizationWide, true
}

// HasOrganizationWide returns a boolean if a field has been set.
func (o *MediaCenterFileCreate) HasOrganizationWide() bool {
	if o != nil && !IsNil(o.OrganizationWide) {
		return true
	}

	return false
}

// SetOrganizationWide gets a reference to the given bool and assigns it to the OrganizationWide field.
func (o *MediaCenterFileCreate) SetOrganizationWide(v bool) {
	o.OrganizationWide = &v
}

// GetPublic returns the Public field value if set, zero value otherwise.
func (o *MediaCenterFileCreate) GetPublic() bool {
	if o == nil || IsNil(o.Public) {
		var ret bool
		return ret
	}
	return *o.Public
}

// GetPublicOk returns a tuple with the Public field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaCenterFileCreate) GetPublicOk() (*bool, bool) {
	if o == nil || IsNil(o.Public) {
		return nil, false
	}
	return o.Public, true
}

// HasPublic returns a boolean if a field has been set.
func (o *MediaCenterFileCreate) HasPublic() bool {
	if o != nil && !IsNil(o.Public) {
		return true
	}

	return false
}

// SetPublic gets a reference to the given bool and assigns it to the Public field.
func (o *MediaCenterFileCreate) SetPublic(v bool) {
	o.Public = &v
}

func (o MediaCenterFileCreate) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MediaCenterFileCreate) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["key"] = o.Key
	if !IsNil(o.OrganizationWide) {
		toSerialize["organization_wide"] = o.OrganizationWide
	}
	if !IsNil(o.Public) {
		toSerialize["public"] = o.Public
	}
	return toSerialize, nil
}

type NullableMediaCenterFileCreate struct {
	value *MediaCenterFileCreate
	isSet bool
}

func (v NullableMediaCenterFileCreate) Get() *MediaCenterFileCreate {
	return v.value
}

func (v *NullableMediaCenterFileCreate) Set(val *MediaCenterFileCreate) {
	v.value = val
	v.isSet = true
}

func (v NullableMediaCenterFileCreate) IsSet() bool {
	return v.isSet
}

func (v *NullableMediaCenterFileCreate) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMediaCenterFileCreate(val *MediaCenterFileCreate) *NullableMediaCenterFileCreate {
	return &NullableMediaCenterFileCreate{value: val, isSet: true}
}

func (v NullableMediaCenterFileCreate) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMediaCenterFileCreate) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


